from . import settings
from .api.licenze import (list as list_licenze, read as read_licenza)
from .api.esche import (list as list_esche, create as create_esca)
from .api.uscite import create as create_uscita


def cerca_stringa_in_bacino(stringa, bacino, id_licenza=None, note=None, intervallo=5):
    if settings.DEBUG:
        print('cerca_stringa_in_bacino', bacino, 'stringa', stringa)

    licenze = list_licenze()
    esche = list_esche()
    licenze = licenze.get('data', [])
    esche = esche.get('data', [])
    licenza = None

    if id_licenza is None:
        for el in licenze:
            if el['bacino'] == bacino:
                if el['active']:
                    licenza = el
                    break
    else:
        licenza = read_licenza(id_licenza).get('data')[0]

        if licenza['bacino'] != bacino:
            raise Exception('This licenza is for {}.'.format(licenza['bacino']))

    esca = None
    for el in esche:
        if el['stringa'] == stringa:
            if el['active']:
                esca = el
                break

    if esca is None:
        esca = create_esca(stringa=stringa).get('data')[0]

    if licenza is None:
        raise Exception('Unable to find licenza for bacino {}.'.format(bacino))
    if esca is None:
        raise Exception('Unable to find esca with stringa "{}".'.format(stringa))

    obj = {
        'licenza': licenza['uuid'],
        'esca': esca['uuid'],
        'intervallo': intervallo
    }
    if note is not None:
        obj['note'] = note

    uscita = create_uscita(**obj)

    return uscita
